/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_SVOP                                                     */
/* Tabela : SERVOPER                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 02/08/2001 - Newton Neves dos Santos                                       */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_SVOP
BEFORE INSERT OR UPDATE OR DELETE
ON SERVOPER FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUSVOP := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDSERVFILI,0) <> NVL(:NEW.CDSERVFILI,0))  OR
         (NVL(:OLD.CDFILIAL,0)   <> NVL(:NEW.CDFILIAL,0))   OR
         (NVL(:OLD.CDOPERADOR,0) <> NVL(:NEW.CDOPERADOR,0)) THEN
         :NEW.DTULTATUSVOP := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('SERVOPER', :OLD.CDFILIAL, 'CDOPERADOR='||:OLD.CDOPERADOR||';CDFILIAL='||:OLD.CDFILIAL||';CDSERVFILI='||:OLD.CDSERVFILI||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE SERVOPER MODIFY DTULTATUSVOP DEFAULT SYSDATE
/
