/*Documentos de entrada aprovados (Entrada sem nota fiscal).*/

BEGIN
   DECLARE V_FILEHANDLE  UTL_FILE.FILE_TYPE;
BEGIN
   FOR CUR_FIL IN (
   SELECT F.CDFILIAL, LPAD(TO_CHAR(TO_NUMBER(F.CDFILIAL)),2,'0') AS CDEXPORTEMPR
   FROM FILIAL F, PARAMEMPRESA P
   WHERE F.CDEMPRESA = P.CDEMPRESA
   ORDER BY F.CDFILIAL) LOOP

      V_FILEHANDLE := UTL_FILE.FOPEN('EXPORA_DIR', 'ExpNFESN'||NVL(CUR_FIL.CDEXPORTEMPR,CUR_FIL.CDFILIAL)||'.txt', 'w');

      FOR CUR_DADOS IN (
         SELECT TO_CHAR(SYSDATE, 'DD-MON-YY')||                       --Data gerao do arquivo
                RPAD(NVL(LC.CDEMPRESA, ' '), 2, ' ')||                --Cdigo da empresa
                RPAD(NVL(LCC.CDCENTCUST, ' '), 5, ' ')||              --Numero do centro de custo
                RPAD(SUBSTR(LC.CDCONTCTBL, 1, 10), 10, ' ')||         --Numero da conta contbil
                RPAD(NVL(PR.CDCENTLUCREN,' '), 3, ' ')||              --Numero do centro de lucro Filial
                DECODE(LCC.CDCENTCUST,'', LPAD(DECODE(ABS(LC.VRLANCAMENT), LC.VRLANCAMENT, ' ', TO_CHAR(NVL(ABS(LC.VRLANCAMENT),0),'999999999990.00')), 18, ' '),
                       LPAD(DECODE(ABS(LCC.VRLANCCUST), LCC.VRLANCCUST, ' ', TO_CHAR(NVL(ABS(LCC.VRLANCCUST),0),'999999999990.00')), 18, ' '))||
                DECODE(LCC.CDCENTCUST,'', LPAD(DECODE(ABS(LC.VRLANCAMENT), LC.VRLANCAMENT, TO_CHAR(NVL(LC.VRLANCAMENT,0),'999999999990.00'),' '), 18, ' '),
                       LPAD(DECODE(ABS(LCC.VRLANCCUST), LCC.VRLANCCUST, TO_CHAR(NVL(LCC.VRLANCCUST,0),'999999999990.00'),' '), 18, ' '))||
                '000'||                                               --Valor Centro Lucro ("000")
                RPAD(' ', 8, ' ')||                                   --Nome do Lanamento do Lote Ctbl
                RPAD(LC.DSHISTLANC, 240, ' ') AS DSARQUIVO            --Histrico do Lancto contbil
         FROM NOTAFISCAL NF, LANCCONT LC, PARAMEMPRESA PR, LANCCCUSTO LCC
         WHERE (NF.CDFILIRECE    = CUR_FIL.CDFILIAL)                 AND
               (NF.IDSTATUS      IN ('A','E'))                       AND
               (NF.DTEMISSAO <= SYSDATE)                             AND
               (NF.CDTIPOOPER    = '10')                             AND
               (NF.IDENTRSAIDOP  = 'E')                              AND
               (NF.DTEXPORTACAO IS NULL)                             AND
               (NF.CDEMPRESA     = LC.CDEMPRESA)                     AND
               (NF.NRLANCTBDOC   = LC.NRLANCCONT)                    AND
               (NF.CDEMPRESA     = PR.CDEMPRESA)                     AND
               (LC.CDEMPRESA     = LCC.CDEMPRESA (+))                AND
               (LC.NRLANCCONT    = LCC.NRLANCCONT (+))               AND
               (LC.NRSEQLANC     = LCC.NRSEQLANC (+))) LOOP

         UTL_FILE.PUT(V_FILEHANDLE, CUR_DADOS.DSARQUIVO||CHR(13)||CHR(10));
         UTL_FILE.FFLUSH(V_FILEHANDLE);
      END LOOP;

      UTL_FILE.FCLOSE(V_FILEHANDLE);
   END LOOP;
END;
END;
/
