/* Sistemas Integrados TEKNISA

Nome: 0509_DFESTPS_ATUALIZA_CUSTO_COMPLEMENTO.SQL

Descrio:
Procedimento para atualizao do valor de estoque dos tens com
o valor do documento de complemento

Criao:
04/10/2005 - Fabrcio Marcelo da Silva
*/

IF EXISTS (SELECT
              *
           FROM SYSOBJECTS O, SYSUSERS U
           WHERE
	           O.NAME = 'ATUALIZA_CUSTO_COMPLEMENTO' AND
	           TYPE = 'P' 			  AND
              U.UID = O.UID        AND
              U.NAME = USER)

DROP PROCEDURE ATUALIZA_CUSTO_COMPLEMENTO
GO

CREATE PROCEDURE ATUALIZA_CUSTO_COMPLEMENTO
   @P_CDFILIAL     VARCHAR(04),
   @P_NRLANCTONF   VARCHAR(10),
   @P_VRNOTAFISC   DOUBLE PRECISION
AS
   DECLARE @V_CDFILIORIG   VARCHAR(04);
   DECLARE @V_NRLANCORIG   VARCHAR(10);
   DECLARE @V_CDFILIESTQ   VARCHAR(04);
   DECLARE @V_NRLANCESTQ   VARCHAR(10);

   DECLARE @V_VRTTLANESTQ  DOUBLE PRECISION;
   DECLARE @V_VRTTLANBRUT  DOUBLE PRECISION;
   DECLARE @V_VRTTCUSENTR  DOUBLE PRECISION;

   DECLARE @V_VRLANCTOEST  DOUBLE PRECISION;
   DECLARE @V_VRLANCTOBRUT DOUBLE PRECISION;
   DECLARE @V_VRCUSTENTR   DOUBLE PRECISION;
   DECLARE @V_VRFATOCONV   DOUBLE PRECISION;

   DECLARE @V_COUNT        NUMERIC;

   DECLARE @V_ITLANC_NRSEQUITEM     VARCHAR(04);
   DECLARE @V_ITLANC_VRLANCTOEST    DOUBLE PRECISION;
   DECLARE @V_ITLANC_VRLANCTOBRUT   DOUBLE PRECISION;
   DECLARE @V_ITLANC_VRCUSTENTR     DOUBLE PRECISION;
   DECLARE @V_ITLANC_QTLANCTOEST    DOUBLE PRECISION;
   DECLARE @V_ITLANC_VRFATOCONV     DOUBLE PRECISION;
BEGIN
   SET @V_CDFILIORIG   = NULL;
   SET @V_NRLANCORIG   = NULL;
   SET @V_COUNT        = 0;
   SET @V_CDFILIESTQ   = NULL;
   SET @V_NRLANCESTQ   = NULL;
   SET @V_VRTTLANESTQ  = 0;
   SET @V_VRTTLANBRUT  = 0;
   SET @V_VRTTCUSENTR  = 0;

   SELECT @V_CDFILIORIG = MAX(CDFILIALIT),
          @V_NRLANCORIG = MAX(NRLANCTONFIT)
   FROM ITEMNOTAFISC
   WHERE CDFILIAL   = @P_CDFILIAL    AND
         NRLANCTONF = @P_NRLANCTONF;

   SELECT @V_COUNT = COUNT(*)
   FROM ITEMNOTAFISC I, NOTAFISCAL N
   WHERE I.CDFILIALIT   = @V_CDFILIORIG AND
         I.NRLANCTONFIT = @V_NRLANCORIG AND
         I.CDFILIALIT   = N.CDFILIAL    AND
         I.NRLANCTONFIT = N.NRLANCTONF  AND
         N.CDTIPOOPER   = '06'          AND
         N.IDENTRSAIDOP = 'S';

   IF @V_COUNT = 0 BEGIN
      IF NOT @V_NRLANCORIG IS NULL BEGIN
         SELECT @V_CDFILIESTQ = MAX(CDFILIAL),
                @V_NRLANCESTQ = MAX(NRLANCESTQ)
         FROM LANCTOESTOQ
         WHERE CDFILIAL   = @V_CDFILIORIG AND
               NRLANCTONF = @V_NRLANCORIG;

         SELECT @V_VRTTLANESTQ = SUM(VRLANCTOEST  * QTLANCTOEST),
                @V_VRTTLANBRUT = SUM(VRLANCTOBRUT * QTLANCTOEST),
                @V_VRTTCUSENTR = SUM(VRCUSTENTR)
         FROM ITLANCTOEST
         WHERE CDFILIAL   = @V_CDFILIESTQ AND
               NRLANCESTQ = @V_NRLANCESTQ;

         IF @V_VRTTLANESTQ > 0 BEGIN
            DECLARE C_ITLANCTOEST CURSOR FOR
               SELECT I.NRSEQUITEM,
                      (I.VRLANCTOEST  * QTLANCTOEST) AS VRLANCTOEST,
                      (I.VRLANCTOBRUT * QTLANCTOEST) AS VRLANCTOBRUT,
                      I.VRCUSTENTR, I.QTLANCTOEST, P.VRFATOCONV
               FROM PRODUTO P, ITLANCTOEST I
               WHERE I.CDFILIAL   = @V_CDFILIESTQ AND
                     I.NRLANCESTQ = @V_NRLANCESTQ AND
                     I.CDPRODUTO  = P.CDPRODUTO;
            OPEN C_ITLANCTOEST;
            FETCH NEXT FROM C_ITLANCTOEST INTO @V_ITLANC_NRSEQUITEM, @V_ITLANC_VRLANCTOEST, @V_ITLANC_VRLANCTOBRUT,
                                               @V_ITLANC_VRCUSTENTR, @V_ITLANC_QTLANCTOEST, @V_ITLANC_VRFATOCONV;
            WHILE (@@FETCH_STATUS = 0) BEGIN
               SET @V_VRLANCTOEST  = (@V_ITLANC_VRLANCTOEST/@V_VRTTLANESTQ)  * @P_VRNOTAFISC;
               SET @V_VRLANCTOBRUT = (@V_ITLANC_VRLANCTOBRUT/@V_VRTTLANBRUT) * @P_VRNOTAFISC;
               SET @V_VRCUSTENTR   = (@V_ITLANC_VRCUSTENTR/@V_VRTTCUSENTR)   * @P_VRNOTAFISC;

               IF (@V_ITLANC_VRFATOCONV IS NULL) OR (@V_ITLANC_VRFATOCONV = 0) BEGIN
                  SET @V_VRFATOCONV = 1;
               END
               ELSE BEGIN
                  SET @V_VRFATOCONV = @V_ITLANC_VRFATOCONV;
               END;

               SET @V_VRLANCTOEST  = (@V_VRLANCTOEST/@V_ITLANC_QTLANCTOEST)/@V_VRFATOCONV;
               SET @V_VRLANCTOBRUT = (@V_VRLANCTOBRUT/@V_ITLANC_QTLANCTOEST)/@V_VRFATOCONV;

               UPDATE ITLANCTOEST
               SET VRLANCTOEST  = VRLANCTOEST  + @V_VRLANCTOEST,
                   VRLANCTOBRUT = VRLANCTOBRUT + @V_VRLANCTOBRUT,
                   VRCUSTENTR   = VRCUSTENTR + @V_VRCUSTENTR
               WHERE CDFILIAL   = @V_CDFILIESTQ AND
                     NRLANCESTQ = @V_NRLANCESTQ AND
                     NRSEQUITEM = @V_ITLANC_NRSEQUITEM;

               OPEN C_ITLANCTOEST;
               FETCH NEXT FROM C_ITLANCTOEST INTO @V_ITLANC_NRSEQUITEM, @V_ITLANC_VRLANCTOEST, @V_ITLANC_VRLANCTOBRUT,
                                                  @V_ITLANC_VRCUSTENTR, @V_ITLANC_QTLANCTOEST, @V_ITLANC_VRFATOCONV;
            END;
            CLOSE C_ITLANCTOEST;
            DEALLOCATE C_ITLANCTOEST;
         END;
      END;
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'ATUALIZA_CUSTO_COMPLEMENTO','4.11.025';
GO

